using UnityEngine;
using UnityEngine.Events;
using System;
using System.Collections.Generic;
using MeshVR;
using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;
using Battlehub.RTSaveLoad;
using System.Linq;
using UnityEngine.UI;

namespace Ruvik
{
    class PH : MVRScript
    {
        string ASSETBUNDLEPATH;
        string keyString = string.Empty;
        public static JSONStorableFloat sensetivity, rotationSpeed,UIScale,UIOffsetX,UIOffsetY;
        public static JSONStorableBool adjustPosition, alignUpDown,changePose,keepUIOpen;
        public JSONStorableStringChooser savemodes;
        readonly int SAVE_MODE_KEEP = 0;
        readonly int SAVE_MODE_RETRIEVE = 1;
        readonly int SAVE_MODE_CLEAR = 2;
        public static int SAVE_MODE = 1;
        GameObject identity;
        public static JSONStorableBool actBool = new JSONStorableBool("motion activation Key", false);
        public static JSONStorableBool switchMotionBool = new JSONStorableBool("motion switching Key(position/rotation)", false);
        public static JSONStorableBool switchAxisBool = new JSONStorableBool("axis switching Key(XY/Z)", false);
	public static JSONStorableBool useOldPresets;

        public void OnBindingsListRequested(List<object> bindings)
        {
            bindings.Add(new JSONStorableAction("activate/deactive UI", () => PHUI.menuUIActive = !PHUI.menuUIActive));
            bindings.Add(new JSONStorableAction("clear selected bones", () => PHUI.ClearActiveNodes()));
            bindings.Add(new JSONStorableAction("ik link", () => PHUtils.IKLink()));
            bindings.Add(new JSONStorableAction("reset linking state", () => PHUtils.ResetLink_method()));
            bindings.Add(new JSONStorableAction("reset pose", () => PHUtils.ResetPose_method()));
            bindings.Add(new JSONStorableAction("undo", () => PHUndo.RestoreState()));
            bindings.Add(new JSONStorableAction("load Pose", () => PHUtils.LoadPose(true)));
            bindings.Add(new JSONStorableAction("save Pose", () => { PHUI.savePosePrompt.SetActive(true);}));
            bindings.Add(new JSONStorableAction("switch posing mode", () => { PHUI.ToggleBodyPosing();}));
            bindings.Add(actBool);
            bindings.Add(switchMotionBool);
            bindings.Add(switchAxisBool);
        }
        public static string GetPluginPath(MVRScript self)
        {
            string id = self.name.Substring(0, self.name.IndexOf('_'));
            string filename = self.manager.GetJSON()["plugins"][id].Value;
            return filename.Substring(0, filename.LastIndexOfAny(new char[] { '/', '\\' }));
        }
        void Update()
        {
            ProccesKeyBindings();
            PHUtils.UpdateStates();
            if (!keepUIOpen.valNoCallback)
            {
                if (PHUI.menuUIActive)
                    PHUI.PHMenuSetActive(SuperController.singleton.MainHUDVisible);
                else
                    PHUI.PHMenuSetActive(false);
            }
            else
                PHUI.PHMenuSetActive(PHUI.menuUIActive);
        }
        public override void Init()
        {
            List<string> modes = new List<string>()
            {
                "Keep","Retrieve","Clear"
            };
            savemodes = new JSONStorableStringChooser("switch selection mode", modes, modes[1], "switch selection");
            sensetivity = new JSONStorableFloat("sensetivity", 1.0f, 0.1f, 4.0f);
            rotationSpeed = new JSONStorableFloat("rotation Speed", 2.5f, 0.1f, 10.0f);
            UIScale = new JSONStorableFloat("UI Scale", 1.0f, 0.5f, 2.0f);
            UIOffsetX = new JSONStorableFloat("UI Offset X", 10.0f, 0.0f, 50.0f);
            UIOffsetY = new JSONStorableFloat("UI Offset Y", 10.0f, 0.0f, 50.0f);
            sensetivity.storeType = JSONStorableParam.StoreType.Full;
            rotationSpeed.storeType = JSONStorableParam.StoreType.Full;
            savemodes.storeType = JSONStorableParam.StoreType.Full;
            rotationSpeed.storeType = JSONStorableParam.StoreType.Full;
            UIScale.storeType = JSONStorableParam.StoreType.Full;
            UIOffsetX.storeType = JSONStorableParam.StoreType.Full;
            UIOffsetY.storeType = JSONStorableParam.StoreType.Full;

            SuperController.singleton.BroadcastMessage("OnActionsProviderAvailable", this, SendMessageOptions.DontRequireReceiver);
            ASSETBUNDLEPATH = GetPluginPath(this) + "/assets/PH.assetbundle";
            Request request = new Request { path = ASSETBUNDLEPATH, callback = OnAssetBundleLoaded };
            AssetLoader.QueueLoadAssetBundleFromFile(request);

            identity = new GameObject();
            identity.transform.position = Vector3.zero;
            identity.transform.rotation = Quaternion.identity;
            identity.transform.localScale = Vector3.one;
            PHUtils.motionTransform = new Transform[3] { null, identity.transform, SuperController.singleton.lookCamera.transform };

            PHLinker.InitGraph();

            RegisterAction(new JSONStorableAction("activate/deactive UI", () => PHUI.menuUIActive = !PHUI.menuUIActive));
            RegisterAction(new JSONStorableAction("clear selected bones", () => PHUI.ClearActiveNodes()));
            RegisterAction(new JSONStorableAction("ik link", () => PHUtils.IKLink()));
            RegisterAction(new JSONStorableAction("reset linking state", () => PHUtils.ResetLink_method()));
            RegisterAction(new JSONStorableAction("reset pose", () => PHUtils.ResetPose_method()));
            RegisterAction(new JSONStorableAction("undo", () => PHUndo.RestoreState()));

            var bb1 = CreatePopup(savemodes, true); bb1.popup.onValueChangeUnityEvent.AddListener(delegate (string a)
            {
                switch (a.ToLower())
                {
                    case "clear":
                        SAVE_MODE = SAVE_MODE_CLEAR;
                        break;
                    case "retrieve":
                        SAVE_MODE = SAVE_MODE_RETRIEVE;
                        break;
                    case "keep":
                        SAVE_MODE = SAVE_MODE_KEEP;
                        break;
                }
            });
            var btn = CreateButton("Show UI", false); btn.height = bb1.height; btn.button.onClick.AddListener(delegate () { PHUI.menuUIActive = true; });

            CreateSlider(sensetivity, false);
            CreateSlider(rotationSpeed, true);

            RegisterFloat(sensetivity);
            RegisterFloat(rotationSpeed);

            CreateSpacer(true).height = 20;
            CreateSpacer(false).height = 20;

            PHUtils.xPosMultiplier = CreateInverseButton("invert X Pos", false, delegate (bool a) { PHUtils.xPosMultiplier = a ? -1.0f : 1.0f; });
            PHUtils.yPosMultiplier = CreateInverseButton("invert Y Pos", false, delegate (bool a) { PHUtils.yPosMultiplier = a ? -1.0f : 1.0f; });
            PHUtils.zPosMultiplier = CreateInverseButton("invert Z Pos", false, delegate (bool a) { PHUtils.zPosMultiplier = a ? -1.0f : 1.0f; });
            PHUtils.xRotMultiplier = CreateInverseButton("invert X Rot", true, delegate (bool a) { PHUtils.xRotMultiplier = a ? -1.0f : 1.0f; });
            PHUtils.yRotMultiplier = CreateInverseButton("invert Y Rot", true, delegate (bool a) { PHUtils.yRotMultiplier = a ? -1.0f : 1.0f; });
            PHUtils.zRotMultiplier = CreateInverseButton("invert Z Rot", true, delegate (bool a) { PHUtils.zRotMultiplier = a ? -1.0f : 1.0f; });

            CreateSpacer(true).height = 20;
            CreateSpacer(false).height = 20;

            adjustPosition = new JSONStorableBool("adjust_position", true);
	    useOldPresets = new JSONStorableBool("use old presets", false);
            adjustPosition.storeType = JSONStorableParam.StoreType.Full;
            RegisterBool(adjustPosition);
            CreateToggle(adjustPosition, true);
            useOldPresets.storeType = JSONStorableParam.StoreType.Full;
            RegisterBool(useOldPresets);

            alignUpDown = new JSONStorableBool("align_up_down", true);
            alignUpDown.storeType = JSONStorableParam.StoreType.Full;
            RegisterBool(alignUpDown);
            CreateToggle(alignUpDown, false);


            CreateSpacer(true).height = 20;
            CreateSpacer(false).height = 20;


            CreateSlider(UIScale, false).slider.onValueChanged.AddListener((float val) => { GameObject.Find("PH_root").GetComponent<RectTransform>().localScale = Vector3.one * val; });
            CreateSlider(UIOffsetX, true).slider.onValueChanged.AddListener((float val) => { GameObject.Find("PH_root").GetComponent<RectTransform>().anchoredPosition = new Vector3(-val, UIOffsetY.valNoCallback, 0); });
            CreateSlider(UIOffsetY, true).slider.onValueChanged.AddListener((float val) => { GameObject.Find("PH_root").GetComponent<RectTransform>().anchoredPosition = new Vector3(-UIOffsetX.valNoCallback, val, 0); });
            changePose = new JSONStorableBool("change facial expression", true);
            changePose.storeType = JSONStorableParam.StoreType.Full;
            RegisterBool(changePose);
            CreateToggle(changePose, false);

            keepUIOpen = new JSONStorableBool("keep UI open", false);
            keepUIOpen.storeType = JSONStorableParam.StoreType.Full;
            RegisterBool(keepUIOpen);
            CreateToggle(keepUIOpen, false);

            RegisterFloat(UIScale);
            RegisterFloat(UIOffsetX);
            RegisterFloat(UIOffsetY);
            RegisterStringChooser(savemodes);

            CreateToggle(useOldPresets, true);
	    CreateTextField( new JSONStorableString("Help",
                    "this will be removed next update\n\n" +
		    "The check box on the right lets you load older .handpose presets instead of the new .json preset, which have the benefit of having a preview that you can set yourself.\n\n" +
                    "if you want to use older handpose presets, you can either rename them to .json load them and resave them with a preview image, or check the box on the right\n\n"),false);
        }
        public float CreateInverseButton(string name, bool right, UnityAction<bool> toggleAction)
        {
            JSONStorableBool storableBool = new JSONStorableBool(name, false);
            storableBool.storeType = JSONStorableParam.StoreType.Full;
            RegisterBool(storableBool);
            CreateToggle(storableBool, right);
            storableBool.toggle.onValueChanged.AddListener(toggleAction);
            return storableBool.val ? 1.0f : -1.0f;
        }

        bool beingHeld = false;
        void ProccesKeyBindings()
        {
            if (Input.GetKeyDown(KeyCode.Escape))
            {
                PHUI.savePosePrompt.SetActive(false);
            }
            if (actBool.valNoCallback && !beingHeld)
            {
                beingHeld = true;
                PHUtils.PreMoveControllers();
            }

            if (actBool.valNoCallback && beingHeld)
            {
                float x, y;
                Vector3 moveby;
                x = Input.GetAxis("Mouse X");
                y = Input.GetAxis("Mouse Y");
                moveby = switchAxisBool.valNoCallback ? new Vector3(0, 0, x + y) : new Vector3(x, y, 0);
                PHUtils.MoveActiveNodes(moveby, !switchMotionBool.valNoCallback);
            }
            if (!actBool.valNoCallback && beingHeld)
            {
                beingHeld = false;
                PHUtils.PostMoveControllers();
            }
        }
        public void OnDestroy()
        {

            AssetLoader.DoneWithAssetBundleFromFile(ASSETBUNDLEPATH);
            SuperController.singleton.BroadcastMessage("OnActionsProviderDestroyed", this, SendMessageOptions.DontRequireReceiver);
            PHUI.PHMenuDesroy();
            Destroy(identity);
        }
        public void OnDisable()
        {
            PHUI.PHMenuSetActive(false);
        }
        public void OnEnable()
        {
            PHUI.PHMenuSetActive(true);
        }
        private void OnAssetBundleLoaded(Request aRequest)
        {
            var PHUIAsset = aRequest.assetBundle.LoadAsset<GameObject>("Assets/ph/posinghelperui.prefab");
            var off_off = aRequest.assetBundle.LoadAsset<Sprite>("Assets/ph/off_off.png");
            var off_on = aRequest.assetBundle.LoadAsset<Sprite>("Assets/ph/off_on.png");
            var on_off = aRequest.assetBundle.LoadAsset<Sprite>("Assets/ph/on_off.png");
            var on_on = aRequest.assetBundle.LoadAsset<Sprite>("Assets/ph/on_on.png");
            var body = aRequest.assetBundle.LoadAsset<Sprite>("Assets/ph/body.png");
            if (PHUIAsset != null)
            {
                PHUI.phGameObject = Instantiate(PHUIAsset);
                PHUI.stateTextures.Add("off_off", off_off);
                PHUI.stateTextures.Add("off_on", off_on);
                PHUI.stateTextures.Add("on_off", on_off);
                PHUI.stateTextures.Add("on_on", on_on);
                PHUI.stateTextures.Add("body", body);
                try
                {
                    PHUI.InitPHUI();
                }
                catch (Exception e)
                {
                    SuperController.LogError(e.Source+e.Message);
                }
            }
        }

    }
}
