using System;
using UnityEngine.UI;

namespace Ruvik
{
    class PHFingerSliders : MVRScript
    {
        public override void Init()
        {
            InitSlider("Thumb");
            CreateCarpalSliders();
            InitSlider("Index");
            InitSlider("Mid");
            InitSlider("Ring");
            InitSlider("Pinky");
        }
        void CreateCarpalSliders()
        {
            CreateSliderAndRegister($"rCarpal1X",true);
            CreateSliderAndRegister($"rCarpal1Y",true);
            CreateSliderAndRegister($"rCarpal1Z",true);
            CreateSliderAndRegister($"rCarpal2X",true);
            CreateSliderAndRegister($"rCarpal2Y",true);
            CreateSliderAndRegister($"rCarpal2Z",true);
            CreateSliderAndRegister($"lCarpal1X",false);
            CreateSliderAndRegister($"lCarpal1Y",false);
            CreateSliderAndRegister($"lCarpal1Z",false);
            CreateSliderAndRegister($"lCarpal2X",false);
            CreateSliderAndRegister($"lCarpal2Y",false);
            CreateSliderAndRegister($"lCarpal2Z",false);
        }
        void CreateSliderAndRegister(string name,bool side)
        {
            var slider = new JSONStorableFloat(name,0.0f, -120.0f, 120.0f);
            RegisterFloat(slider);
            slider.RegisterSlider(CreateSlider(slider,side).slider);
        }
        void InitSlider(string name)
        {
            CreateSliderAndRegister($"r{name}1X",true);
            CreateSliderAndRegister($"r{name}1Y",true);
            CreateSliderAndRegister($"r{name}1Z",true);
            CreateSliderAndRegister($"r{name}2X",true);
            CreateSliderAndRegister($"r{name}2Y",true);
            CreateSliderAndRegister($"r{name}2Z",true);
            CreateSliderAndRegister($"r{name}3X",true);
            CreateSliderAndRegister($"r{name}3Y",true);
            CreateSliderAndRegister($"r{name}3Z",true);
            CreateSliderAndRegister($"l{name}1X",false);
            CreateSliderAndRegister($"l{name}1Y",false);
            CreateSliderAndRegister($"l{name}1Z",false);
            CreateSliderAndRegister($"l{name}2X",false);
            CreateSliderAndRegister($"l{name}2Y",false);
            CreateSliderAndRegister($"l{name}2Z",false);
            CreateSliderAndRegister($"l{name}3X",false);
            CreateSliderAndRegister($"l{name}3Y",false);
            CreateSliderAndRegister($"l{name}3Z",false);
        }
    }
}